exports.main = function (command, options, cli) {
   var dnode      = require('dnode'),
       handlers   = {};

   dnode.connect(63200, function (remote, connection) {
      handlers[command](remote, function() {
         connection.end();
      });
   });
   
   handlers.status = function (remote, done) {
      remote.status(function (err, res) {
         if (err) {
            cli.error(err);
            done();
         } else {
            cli.ok(JSON.stringify(res, false, 2));
            done();
         }
      });
   };

   handlers.reseterror = function (remote, done) {
      remote.reseterror(function (err, res) {
         if (err) {
            cli.error(err);
            done();
         } else {
            cli.ok(res);
            done();
         }
      });
   };

   handlers.stop = function (remote, done) {
      remote.stop(done);
   };
};

