var vows       = require('vows'),
    assert     = require('assert'),
    food       = require('../lib/index').client,
    readfile   = require('fs').readFile,
    async      = require('async'),
    _          = require('underscore');

var suite = vows.describe('foodjs');

function isValidMenu (err, menu) {
   if (err) throw err;
   assert.isObject(menu);
   //console.dir(menu);
   _.each(menu, function (item) {
      assert.isArray(item);
      _.each(item, function (food) {
         assert.isString(food);
      });
   });
}

var rutgers = food();
suite.addBatch({
	'getMenu busch lunch': {
		topic: function() { rutgers.getMenu("busch", "lunch", this.callback); },
		'is valid menu': isValidMenu
	},
   'getMenu livingston dinner': {
      topic: function () { rutgers.getMenu("livingston", "dinner", this.callback); },
      'is valid menu': isValidMenu
   },
	'getMenu brower lunch': {
		topic: function() { rutgers.getMenu("brower", "lunch", this.callback); },
		'is valid menu': isValidMenu
	},
});

suite.export(module);

