<?php

function reportError($lineNo, $why, $ds=NULL) {
	// FIXME: We should always output valid JSON, instead of strings

	if ($ds) {
		$ldaperrno = ldap_errno($ds);
		$ldaperrstr = ldap_err2str($ldaperrno);
	} else {
		$ldaperrno = 0;
		$ldaperrstr = "";
	}
	
   $return = array();

   $return['success'] = FALSE;
   $return['error'] = $ldaperrstr;
   $return['why'] = $why;
   $return['line'] = $lineNo;
   $return['crap'] = $ldaperrno;

   echo json_encode($return);

	die($lineNo);
}

function checkLdap($netid, $credentials) {
	$oldErr = error_reporting(0);
	$basedn = "dc=rutgers,dc=edu";
	$server = "ldap://ldap.rutgers.edu";

	// Add more attributes here as needed.
	// SECURITY: For speed and as a security onion layer, don't specify more than is needed here.
	$requestedAttrs = array(
      "uid", 
      "rulinkRutgersEduCampusService", 
      "eduPersonPrimaryAffiliation"
   );

	$ds = ldap_connect($server) 
      or reportError(__LINE__,  "Connection failure");
	ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3)
      or reportError(__LINE__, "LDAP Version 3 required", $ds);
	ldap_start_tls($ds) 
      or reportError(__LINE__, "Failed to start encryption", $ds);

   // form an RDN: "uid=root,ou=people,dc=rutgers,dc=edu"
	$rdn = "uid=" . $netid . ",ou=people," . $basedn; 
	$bind = ldap_bind($ds, $rdn, $credentials) 
      or reportError(__LINE__, "Failed to perform bind", $ds);
	$res = ldap_search($ds, $basedn, "(uid=$netid)", $requestedAttrs) 
      or reportError(__LINE__, "Failed to perform search", $ds);
	$entries = ldap_get_entries($ds, $res) 
      or reportError(__LINE__, "Failed to retrieve entries", $ds);

	error_reporting($oldErr);
	return $entries;
}

$result = checkLdap($_POST['netid'], $_POST['password']);
$result['success'] = TRUE;
echo json_encode($result);

?>
