<?php
/*
   File: feedback/index.php
   This script handles feedback submitted through the channel on the mobile app.
   It expects a post request.

   Parameters:
      message     - *string* message the user answered
      email       - *string* user's email
      subject     - *string* the category selected on the feedback page
      wants_response - *bool* whether or not the user wants a response
      channel     - *string* name of the channel the user chose, if applicable

   Returns:
      json object, will contain a field called 'success' upon success and
      'error' upon failure.  These will be set to strings of useful data.
      For example:
      > {"success":"Your message was submitted successfully"}
*/

   include('config.php');
   include('database.php');
	include('helpers.php');

	$rv = array();

	$feedback_arr = $_POST;

	//Message is required.
	if(!isset($feedback_arr['message']) || !$feedback_arr['message'])
	{
		$rv['errors'][] = 'Please enter a message.';			
	}

	$email = isset($feedback_arr['email']) ? $feedback_arr['email'] : '';

	//validate email
	//if($email && !is_valid_email($email))
	//{
	//	$rv['errors'][] = 'The email you entered is invalid.';
	//}

	//If there are any errors, die.
	if(isset($rv['errors']))
	{
		die(json_encode($rv));
	}

	$message = $feedback_arr['message'];	
	$subject = isset($feedback_arr['subject']) ? $feedback_arr['subject'] : '';
   $channel = isset($feedback_arr['channel']) ? $feedback_arr['channel'] : '';

	db_query('INSERT INTO feedback (subject, email, message, wantsResponse, channel) VALUES("%s", "%s", "%s", %d, "%s")', $subject, $email, $message, $feedback_arr['wants_response'], $channel);

	//Let's not print out errors if we got this far.
	unset($rv['errors']);
	$rv['success'] = 'Your message was submitted successfully';

   if (isset($_POST['redirect']))
      header('Location: ' .$_POST['redirect']. '?output=' .urlencode(json_encode($rv)));
   else
	   echo json_encode($rv);

?>
