/*
   File: mobile.sql
   Table definitions for Rutgers Mobile Web
*/

/*
   Table: feedback
   Stores feedback from users gathered from the in-app channel as well as
   the website.   

   Fields:
      id       - *int(10) unsigned NOT NULL AUTO_INCREMENT* unique identifier
      subject  - *varchar(255) NOT_NULL* subject of the feedback message
      message  - *text NOT_NULL* feedback message
      date     - *timestamp NOT_NULL DEFAULT CURRENT_TIMESTAMP* feedback message
      email    - *varchar(255) NOT_NULL* email to respond to 
      wantsResponse  - *bool DEFAULT FALSE* true if the user wants a response
      channel    - *varchar(255) NOT_NULL* channel which the feedback is about
      
*/

DROP TABLE IF EXISTS `feedback`;
CREATE TABLE `feedback` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `subject` varchar(255) NOT NULL default '',
  `message` text NOT NULL default '',
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `email` varchar(255) NOT NULL default '',
  `wantsResponse` bool DEFAULT FALSE,
  `channel` varchar(255) NOT NULL default '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;
